diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -32,7 +32,9 @@
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
 
+#include <algorithm>
 #include <iomanip>
 
 #define Min(a, b) ((a < b) ? a : b)
@@ -43,6 +45,42 @@
 namespace ns3
 {
 
+/**
+ * @brief standard information for each modulation class
+ */
+const std::map<WifiModulationClass, MinstrelHtWifiManager::StandardInfo> minstrelHtStandardInfos{
+    {
+        WIFI_MOD_CLASS_HT,
+        {
+            .groupType = WIFI_MINSTREL_GROUP_HT,
+            .maxMcs = 7,
+            .maxWidth = MHz_u{40},
+            .guardIntervals = {NanoSeconds(800), NanoSeconds(400)},
+            .maxStreams = 4,
+        },
+    },
+    {
+        WIFI_MOD_CLASS_VHT,
+        {
+            .groupType = WIFI_MINSTREL_GROUP_VHT,
+            .maxMcs = 9,
+            .maxWidth = MHz_u{160},
+            .guardIntervals = {NanoSeconds(800), NanoSeconds(400)},
+            .maxStreams = 8,
+        },
+    },
+    {
+        WIFI_MOD_CLASS_HE,
+        {
+            .groupType = WIFI_MINSTREL_GROUP_HE,
+            .maxMcs = 11,
+            .maxWidth = MHz_u{160},
+            .guardIntervals = {NanoSeconds(3200), NanoSeconds(1600), NanoSeconds(800)},
+            .maxStreams = 8,
+        },
+    },
+};
+
 /// MinstrelHtWifiRemoteStation structure
 struct MinstrelHtWifiRemoteStation : MinstrelWifiRemoteStation
 {
@@ -137,7 +175,7 @@
 MinstrelHtWifiManager::~MinstrelHtWifiManager()
 {
     NS_LOG_FUNCTION(this);
-    for (uint8_t i = 0; i < m_numGroups; i++)
+    for (std::size_t i = 0; i < m_numGroups; i++)
     {
         m_minstrelGroups[i].ratesFirstMpduTxTimeTable.clear();
         m_minstrelGroups[i].ratesTxTimeTable.clear();
@@ -173,6 +211,76 @@
 }
 
 void
+MinstrelHtWifiManager::InitializeGroups(WifiModulationClass mc)
+{
+    const auto& standardInfos = minstrelHtStandardInfos.at(mc);
+    for (MHz_u chWidth{20}; chWidth <= standardInfos.maxWidth; chWidth *= 2)
+    {
+        for (const auto& guardInterval : standardInfos.guardIntervals)
+        {
+            for (uint8_t streams = 1; streams <= standardInfos.maxStreams; ++streams)
+            {
+                const auto groupId =
+                    GetGroupIdForType(standardInfos.groupType, streams, guardInterval, chWidth);
+
+                m_minstrelGroups[groupId].streams = streams;
+                m_minstrelGroups[groupId].gi = guardInterval;
+                m_minstrelGroups[groupId].chWidth = chWidth;
+                m_minstrelGroups[groupId].type = standardInfos.groupType;
+                m_minstrelGroups[groupId].isSupported = false;
+
+                // Check capabilities of the device
+                if ((((mc >= WIFI_MOD_CLASS_HE) &&
+                      (GetGuardInterval() <=
+                       guardInterval)) || /// Is GI supported by the transmitter?
+                     ((mc < WIFI_MOD_CLASS_HE) &&
+                      !(!GetShortGuardIntervalSupported() &&
+                        (guardInterval.GetNanoSeconds() ==
+                         400)))) /// Is SGI supported by the transmitter?
+                    && (GetPhy()->GetChannelWidth() >=
+                        chWidth) /// Is channel width supported by the transmitter?
+                    && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
+                        streams)) /// Are streams supported by the transmitter?
+                {
+                    m_minstrelGroups[groupId].isSupported = true;
+
+                    // Calculate TX time for all rates of the group
+                    WifiModeList mcsList = GetDeviceMcsList(mc);
+                    for (uint8_t i = 0; i <= standardInfos.maxMcs; ++i)
+                    {
+                        const auto mcsIndex = (mc == WIFI_MOD_CLASS_HT)
+                                                  ? (i + (m_minstrelGroups[groupId].streams - 1) *
+                                                             (standardInfos.maxMcs + 1))
+                                                  : i;
+                        WifiMode mode = mcsList.at(mcsIndex);
+                        // Check for invalid MCSs and do not add time to array.
+                        if (IsValidMcs(streams, chWidth, mode))
+                        {
+                            AddFirstMpduTxTime(groupId,
+                                               mode,
+                                               CalculateMpduTxDuration(streams,
+                                                                       guardInterval,
+                                                                       chWidth,
+                                                                       mode,
+                                                                       FIRST_MPDU_IN_AGGREGATE));
+                            AddMpduTxTime(groupId,
+                                          mode,
+                                          CalculateMpduTxDuration(streams,
+                                                                  guardInterval,
+                                                                  chWidth,
+                                                                  mode,
+                                                                  MIDDLE_MPDU_IN_AGGREGATE));
+                        }
+                    }
+                    NS_LOG_DEBUG("Initialized group " << groupId << ": (" << +streams << ","
+                                                      << guardInterval << "," << chWidth << ")");
+                }
+            }
+        }
+    }
+}
+
+void
 MinstrelHtWifiManager::DoInitialize()
 {
     NS_LOG_FUNCTION(this);
@@ -183,20 +291,21 @@
      * station.
      */
 
+    m_numGroups = 0;
     if (GetHtSupported())
     {
-        m_numGroups = MAX_HT_SUPPORTED_STREAMS * MAX_HT_STREAM_GROUPS;
-        m_numRates = MAX_HT_GROUP_RATES;
+        m_numGroups += GetNumGroups(WIFI_MOD_CLASS_HT);
+        m_numRates = minstrelHtStandardInfos.at(WIFI_MOD_CLASS_HT).maxMcs + 1;
     }
     if (GetVhtSupported())
     {
-        m_numGroups += MAX_VHT_SUPPORTED_STREAMS * MAX_VHT_STREAM_GROUPS;
-        m_numRates = MAX_VHT_GROUP_RATES;
+        m_numGroups += GetNumGroups(WIFI_MOD_CLASS_VHT);
+        m_numRates = minstrelHtStandardInfos.at(WIFI_MOD_CLASS_VHT).maxMcs + 1;
     }
     if (GetHeSupported())
     {
-        m_numGroups += MAX_HE_SUPPORTED_STREAMS * MAX_HE_STREAM_GROUPS;
-        m_numRates = MAX_HE_GROUP_RATES;
+        m_numGroups += GetNumGroups(WIFI_MOD_CLASS_HE);
+        m_numRates = minstrelHtStandardInfos.at(WIFI_MOD_CLASS_HE).maxMcs + 1;
     }
 
     /**
@@ -217,197 +326,26 @@
     if (GetHtSupported())
     {
         // Initialize all HT groups
-        for (MHz_u chWidth = 20; chWidth <= MAX_HT_WIDTH; chWidth *= 2)
-        {
-            for (int gi = 800; gi >= 400;)
-            {
-                const auto guardInterval = NanoSeconds(gi);
-                for (uint8_t streams = 1; streams <= MAX_HT_SUPPORTED_STREAMS; streams++)
-                {
-                    uint8_t groupId = GetHtGroupId(streams, guardInterval, chWidth);
-
-                    m_minstrelGroups[groupId].streams = streams;
-                    m_minstrelGroups[groupId].gi = guardInterval;
-                    m_minstrelGroups[groupId].chWidth = chWidth;
-                    m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_HT;
-                    m_minstrelGroups[groupId].isSupported = false;
-
-                    // Check capabilities of the device
-                    if (!(!GetShortGuardIntervalSupported() &&
-                          (gi == 400)) /// Is SGI supported by the transmitter?
-                        && (GetPhy()->GetChannelWidth() >=
-                            chWidth) /// Is channel width supported by the transmitter?
-                        && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
-                            streams)) /// Are streams supported by the transmitter?
-                    {
-                        m_minstrelGroups[groupId].isSupported = true;
-
-                        // Calculate TX time for all rates of the group
-                        WifiModeList htMcsList = GetHtDeviceMcsList();
-                        for (uint8_t i = 0; i < MAX_HT_GROUP_RATES; i++)
-                        {
-                            uint16_t deviceIndex = i + (m_minstrelGroups[groupId].streams - 1) * 8;
-                            WifiMode mode = htMcsList[deviceIndex];
-                            AddFirstMpduTxTime(groupId,
-                                               mode,
-                                               CalculateMpduTxDuration(GetPhy(),
-                                                                       streams,
-                                                                       guardInterval,
-                                                                       chWidth,
-                                                                       mode,
-                                                                       FIRST_MPDU_IN_AGGREGATE));
-                            AddMpduTxTime(groupId,
-                                          mode,
-                                          CalculateMpduTxDuration(GetPhy(),
-                                                                  streams,
-                                                                  guardInterval,
-                                                                  chWidth,
-                                                                  mode,
-                                                                  MIDDLE_MPDU_IN_AGGREGATE));
-                        }
-                        NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams << ","
-                                                          << guardInterval << "," << chWidth
-                                                          << ")");
-                    }
-                }
-                gi /= 2;
-            }
-        }
+        InitializeGroups(WIFI_MOD_CLASS_HT);
     }
 
     if (GetVhtSupported())
     {
         // Initialize all VHT groups
-        for (MHz_u chWidth = 20; chWidth <= MAX_VHT_WIDTH; chWidth *= 2)
-        {
-            for (int gi = 800; gi >= 400;)
-            {
-                const auto guardInterval = NanoSeconds(gi);
-                for (uint8_t streams = 1; streams <= MAX_VHT_SUPPORTED_STREAMS; streams++)
-                {
-                    uint8_t groupId = GetVhtGroupId(streams, guardInterval, chWidth);
-
-                    m_minstrelGroups[groupId].streams = streams;
-                    m_minstrelGroups[groupId].gi = guardInterval;
-                    m_minstrelGroups[groupId].chWidth = chWidth;
-                    m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_VHT;
-                    m_minstrelGroups[groupId].isSupported = false;
-
-                    // Check capabilities of the device
-                    if (!(!GetShortGuardIntervalSupported() &&
-                          (gi == 400)) /// Is SGI supported by the transmitter?
-                        && (GetPhy()->GetChannelWidth() >=
-                            chWidth) /// Is channel width supported by the transmitter?
-                        && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
-                            streams)) /// Are streams supported by the transmitter?
-                    {
-                        m_minstrelGroups[groupId].isSupported = true;
-
-                        // Calculate TX time for all rates of the group
-                        WifiModeList vhtMcsList = GetVhtDeviceMcsList();
-                        for (uint8_t i = 0; i < MAX_VHT_GROUP_RATES; i++)
-                        {
-                            WifiMode mode = vhtMcsList[i];
-                            // Check for invalid VHT MCSs and do not add time to array.
-                            if (IsValidMcs(GetPhy(), streams, chWidth, mode))
-                            {
-                                AddFirstMpduTxTime(
-                                    groupId,
-                                    mode,
-                                    CalculateMpduTxDuration(GetPhy(),
-                                                            streams,
-                                                            guardInterval,
-                                                            chWidth,
-                                                            mode,
-                                                            FIRST_MPDU_IN_AGGREGATE));
-                                AddMpduTxTime(groupId,
-                                              mode,
-                                              CalculateMpduTxDuration(GetPhy(),
-                                                                      streams,
-                                                                      guardInterval,
-                                                                      chWidth,
-                                                                      mode,
-                                                                      MIDDLE_MPDU_IN_AGGREGATE));
-                            }
-                        }
-                        NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams << ","
-                                                          << gi << "," << chWidth << ")");
-                    }
-                }
-                gi /= 2;
-            }
-        }
+        InitializeGroups(WIFI_MOD_CLASS_VHT);
     }
 
     if (GetHeSupported())
     {
         // Initialize all HE groups
-        for (MHz_u chWidth = 20; chWidth <= MAX_HE_WIDTH; chWidth *= 2)
-        {
-            for (int gi = 3200; gi >= 800;)
-            {
-                const auto guardInterval = NanoSeconds(gi);
-                for (uint8_t streams = 1; streams <= MAX_HE_SUPPORTED_STREAMS; streams++)
-                {
-                    uint8_t groupId = GetHeGroupId(streams, guardInterval, chWidth);
-
-                    m_minstrelGroups[groupId].streams = streams;
-                    m_minstrelGroups[groupId].gi = guardInterval;
-                    m_minstrelGroups[groupId].chWidth = chWidth;
-                    m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_HE;
-                    m_minstrelGroups[groupId].isSupported = false;
-
-                    // Check capabilities of the device
-                    if ((GetGuardInterval() <=
-                         guardInterval) /// Is GI supported by the transmitter?
-                        && (GetPhy()->GetChannelWidth() >=
-                            chWidth) /// Is channel width supported by the transmitter?
-                        && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
-                            streams)) /// Are streams supported by the transmitter?
-                    {
-                        m_minstrelGroups[groupId].isSupported = true;
-
-                        // Calculate tx time for all rates of the group
-                        WifiModeList heMcsList = GetHeDeviceMcsList();
-                        for (uint8_t i = 0; i < MAX_HE_GROUP_RATES; i++)
-                        {
-                            WifiMode mode = heMcsList.at(i);
-                            // Check for invalid HE MCSs and do not add time to array.
-                            if (IsValidMcs(GetPhy(), streams, chWidth, mode))
-                            {
-                                AddFirstMpduTxTime(
-                                    groupId,
-                                    mode,
-                                    CalculateMpduTxDuration(GetPhy(),
-                                                            streams,
-                                                            guardInterval,
-                                                            chWidth,
-                                                            mode,
-                                                            FIRST_MPDU_IN_AGGREGATE));
-                                AddMpduTxTime(groupId,
-                                              mode,
-                                              CalculateMpduTxDuration(GetPhy(),
-                                                                      streams,
-                                                                      guardInterval,
-                                                                      chWidth,
-                                                                      mode,
-                                                                      MIDDLE_MPDU_IN_AGGREGATE));
-                            }
-                        }
-                        NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams << ","
-                                                          << gi << "," << chWidth << ")");
-                    }
-                }
-                gi /= 2;
-            }
-        }
+        InitializeGroups(WIFI_MOD_CLASS_HE);
     }
 }
 
 bool
-MinstrelHtWifiManager::IsValidMcs(Ptr<WifiPhy> phy, uint8_t streams, MHz_u chWidth, WifiMode mode)
+MinstrelHtWifiManager::IsValidMcs(uint8_t streams, MHz_u chWidth, WifiMode mode)
 {
-    NS_LOG_FUNCTION(this << phy << +streams << chWidth << mode);
+    NS_LOG_FUNCTION(this << streams << chWidth << mode);
     WifiTxVector txvector;
     txvector.SetNss(streams);
     txvector.SetChannelWidth(chWidth);
@@ -415,56 +353,74 @@
     return txvector.IsValid();
 }
 
+bool
+MinstrelHtWifiManager::ShouldAddMcsToGroup(WifiMode mode, std::size_t groupId)
+{
+    for (const auto& [mc, infos] : minstrelHtStandardInfos)
+    {
+        if ((m_minstrelGroups[groupId].type == infos.groupType) &&
+            (mode.GetModulationClass() == mc) &&
+            IsValidMcs(m_minstrelGroups[groupId].streams, m_minstrelGroups[groupId].chWidth, mode))
+        {
+            if (mc == WIFI_MOD_CLASS_HT)
+            {
+                /// Check if the HT MCS corresponds to groups number of streams.
+                return ((mode.GetMcsValue() < (m_minstrelGroups[groupId].streams * 8)) &&
+                        (mode.GetMcsValue() >= ((m_minstrelGroups[groupId].streams - 1) * 8)));
+            }
+            return true;
+        }
+    }
+    return false;
+}
+
 Time
-MinstrelHtWifiManager::CalculateMpduTxDuration(Ptr<WifiPhy> phy,
-                                               uint8_t streams,
+MinstrelHtWifiManager::CalculateMpduTxDuration(uint8_t streams,
                                                Time gi,
                                                MHz_u chWidth,
                                                WifiMode mode,
                                                MpduType mpduType)
 {
-    NS_LOG_FUNCTION(this << phy << +streams << gi << chWidth << mode << mpduType);
-    WifiTxVector txvector;
+    NS_LOG_FUNCTION(this << streams << gi << chWidth << mode << mpduType);
+    WifiTxVector txvector{};
     txvector.SetNss(streams);
     txvector.SetGuardInterval(gi);
     txvector.SetChannelWidth(chWidth);
-    txvector.SetNess(0);
-    txvector.SetStbc(false);
     txvector.SetMode(mode);
-    txvector.SetPreambleType(WIFI_PREAMBLE_HT_MF);
+    txvector.SetPreambleType(GetPreambleForTransmission(mode.GetModulationClass()));
     return WifiPhy::CalculatePhyPreambleAndHeaderDuration(txvector) +
-           WifiPhy::GetPayloadDuration(m_frameLength, txvector, phy->GetPhyBand(), mpduType);
+           WifiPhy::GetPayloadDuration(m_frameLength, txvector, GetPhy()->GetPhyBand(), mpduType);
 }
 
 Time
-MinstrelHtWifiManager::GetFirstMpduTxTime(uint8_t groupId, WifiMode mode) const
+MinstrelHtWifiManager::GetFirstMpduTxTime(std::size_t groupId, WifiMode mode) const
 {
-    NS_LOG_FUNCTION(this << +groupId << mode);
-    auto it = m_minstrelGroups[groupId].ratesFirstMpduTxTimeTable.find(mode);
-    NS_ASSERT(it != m_minstrelGroups[groupId].ratesFirstMpduTxTimeTable.end());
+    NS_LOG_FUNCTION(this << groupId << mode);
+    const auto it = m_minstrelGroups[groupId].ratesFirstMpduTxTimeTable.find(mode);
+    NS_ASSERT(it != m_minstrelGroups[groupId].ratesFirstMpduTxTimeTable.cend());
     return it->second;
 }
 
 void
-MinstrelHtWifiManager::AddFirstMpduTxTime(uint8_t groupId, WifiMode mode, Time t)
+MinstrelHtWifiManager::AddFirstMpduTxTime(std::size_t groupId, WifiMode mode, Time t)
 {
-    NS_LOG_FUNCTION(this << +groupId << mode << t);
+    NS_LOG_FUNCTION(this << groupId << mode << t);
     m_minstrelGroups[groupId].ratesFirstMpduTxTimeTable.insert(std::make_pair(mode, t));
 }
 
 Time
-MinstrelHtWifiManager::GetMpduTxTime(uint8_t groupId, WifiMode mode) const
+MinstrelHtWifiManager::GetMpduTxTime(std::size_t groupId, WifiMode mode) const
 {
-    NS_LOG_FUNCTION(this << +groupId << mode);
+    NS_LOG_FUNCTION(this << groupId << mode);
     auto it = m_minstrelGroups[groupId].ratesTxTimeTable.find(mode);
     NS_ASSERT(it != m_minstrelGroups[groupId].ratesTxTimeTable.end());
     return it->second;
 }
 
 void
-MinstrelHtWifiManager::AddMpduTxTime(uint8_t groupId, WifiMode mode, Time t)
+MinstrelHtWifiManager::AddMpduTxTime(std::size_t groupId, WifiMode mode, Time t)
 {
-    NS_LOG_FUNCTION(this << +groupId << mode << t);
+    NS_LOG_FUNCTION(this << groupId << mode << t);
     m_minstrelGroups[groupId].ratesTxTimeTable.insert(std::make_pair(mode, t));
 }
 
@@ -618,8 +574,8 @@
     }
     else if (station->m_longRetry < CountRetries(station))
     {
-        uint8_t rateId = GetRateId(station->m_txrate);
-        uint8_t groupId = GetGroupId(station->m_txrate);
+        const auto rateId = GetRateId(station->m_txrate);
+        const auto groupId = GetGroupId(station->m_txrate);
         station->m_groupsTable[groupId]
             .m_ratesTable[rateId]
             .numRateAttempt++; // Increment the attempts counter for the rate used.
@@ -635,7 +591,7 @@
                                       MHz_u dataChannelWidth,
                                       uint8_t dataNss)
 {
-    NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+    NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << dataNss);
     auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
@@ -673,8 +629,8 @@
     }
     else
     {
-        uint8_t rateId = GetRateId(station->m_txrate);
-        uint8_t groupId = GetGroupId(station->m_txrate);
+        const auto rateId = GetRateId(station->m_txrate);
+        const auto groupId = GetGroupId(station->m_txrate);
 
         NS_LOG_DEBUG(
             "DoReportDataOk m_txrate = "
@@ -770,7 +726,7 @@
                                              uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << nSuccessfulMpdus << nFailedMpdus << rxSnr << dataSnr
-                         << dataChannelWidth << +dataNss);
+                         << dataChannelWidth << dataNss);
     auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
@@ -790,8 +746,8 @@
 
     UpdatePacketCounters(station, nSuccessfulMpdus, nFailedMpdus);
 
-    uint8_t rateId = GetRateId(station->m_txrate);
-    uint8_t groupId = GetGroupId(station->m_txrate);
+    const auto rateId = GetRateId(station->m_txrate);
+    const auto groupId = GetGroupId(station->m_txrate);
     station->m_groupsTable[groupId].m_ratesTable[rateId].numRateSuccess += nSuccessfulMpdus;
     station->m_groupsTable[groupId].m_ratesTable[rateId].numRateAttempt +=
         nSuccessfulMpdus + nFailedMpdus;
@@ -856,12 +812,12 @@
     /**
      * Get the IDs for all rates.
      */
-    uint8_t maxTpRateId = GetRateId(station->m_maxTpRate);
-    uint8_t maxTpGroupId = GetGroupId(station->m_maxTpRate);
-    uint8_t maxTp2RateId = GetRateId(station->m_maxTpRate2);
-    uint8_t maxTp2GroupId = GetGroupId(station->m_maxTpRate2);
-    uint8_t maxProbRateId = GetRateId(station->m_maxProbRate);
-    uint8_t maxProbGroupId = GetGroupId(station->m_maxProbRate);
+    const auto maxTpRateId = GetRateId(station->m_maxTpRate);
+    const auto maxTpGroupId = GetGroupId(station->m_maxTpRate);
+    const auto maxTp2RateId = GetRateId(station->m_maxTpRate2);
+    const auto maxTp2GroupId = GetGroupId(station->m_maxTpRate2);
+    const auto maxProbRateId = GetRateId(station->m_maxProbRate);
+    const auto maxProbGroupId = GetGroupId(station->m_maxProbRate);
 
     /// For normal rate, we're not currently sampling random rates.
     if (!station->m_isSampling)
@@ -983,39 +939,23 @@
     // the width becomes lower than 20 MHz
     auto width = group.chWidth / 2;
 
-    while (width >= 20)
+    while (width >= MHz_u{20})
     {
         if (width > allowedWidth)
         {
             width /= 2;
             continue;
         }
-
-        switch (group.type)
-        {
-        case WIFI_MINSTREL_GROUP_HT:
-            groupId = GetHtGroupId(group.streams, group.gi, width);
-            break;
-        case WIFI_MINSTREL_GROUP_VHT:
-            groupId = GetVhtGroupId(group.streams, group.gi, width);
-            break;
-        case WIFI_MINSTREL_GROUP_HE:
-            groupId = GetHeGroupId(group.streams, group.gi, width);
-            break;
-        default:
-            NS_ABORT_MSG("Unknown group type: " << group.type);
-        }
-
+        groupId = GetGroupIdForType(group.type, group.streams, group.gi, width);
         group = m_minstrelGroups[groupId];
         if (group.isSupported)
         {
             break;
         }
-
         width /= 2;
     }
 
-    NS_ABORT_MSG_IF(width < 20, "No rate compatible with the allowed width found");
+    NS_ABORT_MSG_IF(width < MHz_u{20}, "No rate compatible with the allowed width found");
 
     return GetIndex(groupId, GetRateId(txRate));
 }
@@ -1046,26 +986,26 @@
     station->m_txrate = UpdateRateAfterAllowedWidth(station->m_txrate, allowedWidth);
     NS_LOG_DEBUG("DoGetDataMode m_txrate= " << station->m_txrate);
 
-    uint8_t rateId = GetRateId(station->m_txrate);
-    uint8_t groupId = GetGroupId(station->m_txrate);
-    uint8_t mcsIndex = station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex;
+    const auto rateId = GetRateId(station->m_txrate);
+    const auto groupId = GetGroupId(station->m_txrate);
+    const auto mcsIndex = station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex;
 
-    NS_LOG_DEBUG("DoGetDataMode rateId= " << +rateId << " groupId= " << +groupId
+    NS_LOG_DEBUG("DoGetDataMode rateId= " << rateId << " groupId= " << groupId
                                           << " mode= " << GetMcsSupported(station, mcsIndex));
 
     McsGroup group = m_minstrelGroups[groupId];
 
     // Check consistency of rate selected.
-    if (((group.type == WIFI_MINSTREL_GROUP_HE) && (group.gi < GetGuardInterval(station))) ||
-        (((group.type == WIFI_MINSTREL_GROUP_HT) || (group.type == WIFI_MINSTREL_GROUP_VHT)) &&
-         (group.gi.GetNanoSeconds() == 400) && !GetShortGuardIntervalSupported(station)) ||
+    if (((group.type >= WIFI_MINSTREL_GROUP_HE) && (group.gi < GetGuardInterval(station))) ||
+        ((group.type < WIFI_MINSTREL_GROUP_HE) && (group.gi.GetNanoSeconds() == 400) &&
+         !GetShortGuardIntervalSupported(station)) ||
         (group.chWidth > GetChannelWidth(station)) ||
         (group.streams > GetNumberOfSupportedStreams(station)))
     {
         NS_FATAL_ERROR("Inconsistent group selected. Group: ("
                        << +group.streams << "," << group.gi << "," << group.chWidth << ")"
                        << " Station capabilities: (" << GetNumberOfSupportedStreams(station) << ","
-                       << ((group.type == WIFI_MINSTREL_GROUP_HE)
+                       << ((group.type >= WIFI_MINSTREL_GROUP_HE)
                                ? GetGuardInterval(station)
                                : NanoSeconds(GetShortGuardIntervalSupported(station) ? 400 : 800))
                        << "," << GetChannelWidth(station) << ")");
@@ -1123,20 +1063,20 @@
          */
 
         // As we are in Minstrel HT, assume the last rate was an HT rate.
-        uint8_t rateId = GetRateId(station->m_txrate);
-        uint8_t groupId = GetGroupId(station->m_txrate);
-        uint8_t mcsIndex = station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex;
-
-        WifiMode lastRate = GetMcsSupported(station, mcsIndex);
-        uint64_t lastDataRate = lastRate.GetNonHtReferenceRate();
-        uint8_t nBasicRates = GetNBasicModes();
+        const auto rateId = GetRateId(station->m_txrate);
+        const auto groupId = GetGroupId(station->m_txrate);
+        const auto mcsIndex = station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex;
+
+        const auto lastRate = GetMcsSupported(station, mcsIndex);
+        const auto lastDataRate = lastRate.GetNonHtReferenceRate();
+        const auto nBasicRates = GetNBasicModes();
 
         WifiMode rtsRate;
         bool rateFound = false;
 
         for (uint8_t i = 0; i < nBasicRates; i++)
         {
-            uint64_t rate = GetBasicMode(i).GetDataRate(20);
+            const auto rate = GetBasicMode(i).GetDataRate(MHz_u{20});
             if (rate <= lastDataRate)
             {
                 rtsRate = GetBasicMode(i);
@@ -1146,10 +1086,9 @@
 
         if (!rateFound)
         {
-            Ptr<WifiPhy> phy = GetPhy();
-            for (const auto& mode : phy->GetModeList())
+            for (const auto& mode : GetPhy()->GetModeList())
             {
-                uint64_t rate = mode.GetDataRate(20);
+                const auto rate = mode.GetDataRate(MHz_u{20});
                 if (rate <= lastDataRate)
                 {
                     rtsRate = mode;
@@ -1173,6 +1112,27 @@
     }
 }
 
+std::list<Ptr<WifiMpdu>>
+MinstrelHtWifiManager::DoGetMpdusToDropOnTxFailure(WifiRemoteStation* station, Ptr<WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << *psdu);
+
+    std::list<Ptr<WifiMpdu>> mpdusToDrop;
+
+    for (const auto& mpdu : *PeekPointer(psdu))
+    {
+        if (!DoNeedRetransmission(station,
+                                  mpdu->GetPacket(),
+                                  (mpdu->GetRetryCount() < GetMac()->GetFrameRetryLimit())))
+        {
+            // this MPDU needs to be dropped
+            mpdusToDrop.push_back(mpdu);
+        }
+    }
+
+    return mpdusToDrop;
+}
+
 bool
 MinstrelHtWifiManager::DoNeedRetransmission(WifiRemoteStation* st,
                                             Ptr<const Packet> packet,
@@ -1216,12 +1176,12 @@
 uint32_t
 MinstrelHtWifiManager::CountRetries(MinstrelHtWifiRemoteStation* station)
 {
-    uint8_t maxProbRateId = GetRateId(station->m_maxProbRate);
-    uint8_t maxProbGroupId = GetGroupId(station->m_maxProbRate);
-    uint8_t maxTpRateId = GetRateId(station->m_maxTpRate);
-    uint8_t maxTpGroupId = GetGroupId(station->m_maxTpRate);
-    uint8_t maxTp2RateId = GetRateId(station->m_maxTpRate2);
-    uint8_t maxTp2GroupId = GetGroupId(station->m_maxTpRate2);
+    const auto maxProbRateId = GetRateId(station->m_maxProbRate);
+    const auto maxProbGroupId = GetGroupId(station->m_maxProbRate);
+    const auto maxTpRateId = GetRateId(station->m_maxTpRate);
+    const auto maxTpGroupId = GetGroupId(station->m_maxTpRate);
+    const auto maxTp2RateId = GetRateId(station->m_maxTpRate2);
+    const auto maxTp2GroupId = GetGroupId(station->m_maxTpRate2);
 
     if (!station->m_isSampling)
     {
